# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xhotfix`](#dsc_xhotfix): The DSC xHotfix resource type. Automatically generated from version 2.8.0.0
* [`dsc_xmicrosoftupdate`](#dsc_xmicrosoftupdate): The DSC xMicrosoftUpdate resource type. Automatically generated from version 2.8.0.0
* [`dsc_xwindowsupdateagent`](#dsc_xwindowsupdateagent): The DSC xWindowsUpdateAgent resource type. Automatically generated from version 2.8.0.0

## Resource types

### `dsc_xhotfix`

The DSC xHotfix resource type.
Automatically generated from version 2.8.0.0

#### Properties

The following properties are available in the `dsc_xhotfix` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the hotfix needs to be installed or uninstalled.

##### `dsc_id`

Data type: `String`

Specifies the Hotfix ID.

##### `dsc_log`

Data type: `Optional[String]`

Specifies the location of the log that contains information from the installation.

#### Parameters

The following parameters are available in the `dsc_xhotfix` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the credential to use to authenticate to a UNC share if the path is on a UNC share.

##### `dsc_path`

namevar

Data type: `String`

Specifies the path that contains the msu file for the hotfix installation.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xmicrosoftupdate`

The DSC xMicrosoftUpdate resource type.
Automatically generated from version 2.8.0.0

#### Parameters

The following parameters are available in the `dsc_xmicrosoftupdate` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Indicates that the Microsoft Update is enabled or is disabled.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwindowsupdateagent`

The DSC xWindowsUpdateAgent resource type.
Automatically generated from version 2.8.0.0

#### Properties

The following properties are available in the `dsc_xwindowsupdateagent` type.

##### `dsc_automaticupdatesnotificationsetting`

Data type: `Optional[String]`

Automatic Updates Notification Setting

##### `dsc_category`

Data type: `Optional[Array[Enum['Security', 'Important', 'Optional']]]`

Indicates if the resource should ensure all Windows Updates are installed or if Automatic updates should be disabled.

##### `dsc_notifications`

Data type: `Optional[Enum['Disabled', 'ScheduledInstallation']]`

Indicates if Windows update agent should notify about updates, see:https://msdn.microsoft.com/en-us/library/windows/desktop/aa385806%28v=vs.85%29.aspx?f=255&MSPPError=-2147217396.

##### `dsc_rebootrequired`

Data type: `Optional[Boolean]`

Indicates if Wua Requires a reboot.  Only returned if UpdateNow is specified.

##### `dsc_source`

Data type: `Enum['WindowsUpdate', 'MicrosoftUpdate', 'WSUS']`

Indicates which source service Windows update agent should use.  Note: WSUS is not implemented in this resource.

##### `dsc_totalupdatesnotinstalled`

Data type: `Optional[Integer[0, 4294967295]]`

Count of updates not installed.  Only returned if UpdateNow is specified.

##### `dsc_updatenow`

Data type: `Optional[Boolean]`

Indicates if the resource should trigger an update during consistency.

#### Parameters

The following parameters are available in the `dsc_xwindowsupdateagent` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

